-- Math Facts v 1.0
-- by Rob (go easy - my first lua proggy)
-- mathfacts@cox.net

math.randomseed( math.random(os.time()) ) -- Seed random number

-- Customizable (but beware..)
hinum = 12 -- is the highest number to use - (Max=31 due to 3 digits display limit)
num_snd = 3 -- # of sound samples. Add in pairs (right/wrong) I used sndrec32.exe to make my own voice waves
hitime = 20 -- Max number of seconds that can pass and still score
hicount = 5 -- score steps; the points scored will change at this interval (hitime/hicount should be integer)
hipts = 3 -- number of points to score per seconds passed
song = "music/axelf.mod" -- The song to play.  (Thanks to "http://www.modarchive.com/")

-- Load Images -- Thanks to misc public domain image collections
tiles = { }
tiles[1] = Image.load("tiles/numbset1.png")
tiles[2] = Image.load("tiles/numbset2.png")
grades = Image.load("tiles/grades.png")
image = { }
image[1] = Image.load("images/newhi.png") ; image[2] = Image.load("images/perfect.png")
image[3] = Image.load("images/blank.png") ; image[4] = Image.load("images/line.png")
image[5] = Image.load("images/boy.png") ; image[6] = Image.load("images/circle_button.png")
image[7] = Image.load("images/cross_button.png") ; image[8] = Image.load("images/triangle_button.png")
image[9] = Image.load("images/square_button.png") ; image[10] = Image.load("images/clear.png") ;
image[11] = Image.load("images/score.png") ; image[12] = Image.load("images/break.png")
image[13] = Image.load("images/gameover.png") ; image[14] = Image.load("images/start_button.png")
image[15] = Image.load("images/dot1.png") ; image[16] = Image.load("images/dot2.png")
image[17] = Image.load("images/dot3.png") ;

-- load sounds
right = { }
right[1] = Sound.load("sounds/chime.wav") ; right[2] = Sound.load("sounds/clapping.wav")
right[3] = Sound.load("sounds/yehaw.wav")
wrong = { }
wrong[1] = Sound.load("sounds/boing.wav") ; wrong[2] = Sound.load("sounds/rasp.wav")
wrong[3] = Sound.load("sounds/explode.wav")
spec = { }
spec[1] = Sound.load("sounds/fanfare.wav")


-- Variables
hifile = "hiscore.txt"
green = Color.new(0, 255, 0) ; white = Color.new(255, 255, 255)
red = Color.new(255, 0, 0) ; yellow = Color.new(255, 255, 0)
width = 50 ; opr_width = 30; pb = 1 ; cur = 1; play_to = 10
spc = 0; number = 0 ; number1 = 0 ; number2 = 0 ; answer = 0
inrow = 1 ; pre_ans=""; prbtype = { } ; prbtype ={1,1,1,1}
tile_type=1 ; music = 0 ; prbx = 25; prby = 40; ansx = 60 ; ansy = 130
count = 0 ; score = 0 ; chosen = 0 ; pointscore = 0; addme = 0
timer = Timer.new() ; pass = 0
guess = { } ; no_guess = { } ; cards = { } ; problems = { } ; problems = { 10,25,50,75 }
opr = { } ; opr ={20,32,33,34} ; oper = { } ; oper = {"*","/","+","-"} ; high = { } ; high = {0,0,0,0}

-- Functions
function new_game()
  count = 0 ;  row = 3 ; player_guess = 0 ; score = 0 ;  pointscore = 0 ; tottime = 0
  last_guess = " " ;   pre_ans = ""
  for a = 1,hinum do
      for b = 1,hinum do
          rec =  ((a*hinum)-hinum)+b
          answ1 = a * b
          answ2 = a + b
          cards[rec] = {num1 = a, num2 = b, ans1 = answ1, ans2 = answ2, mult =0, div = 0,add = 0, sub =0}
      end
  end
end

function get_key()
  bt = 0
  while bt == 0 do
    pad = Controls.read()
    if pad ~= oldPad then
      if pad:up() then bt = 1
      elseif pad:down() then bt = 2
      elseif pad:left() then bt = 3
      elseif pad:right() then bt = 4
      elseif pad:triangle() then bt = 5
      elseif pad:circle() then bt = 6
      elseif pad:cross() then bt = 7
      elseif pad:square() then bt = 8
      elseif pad:l() then bt = 9
      elseif pad:r() then bt = 10
      elseif pad:select() then bt = 11
      elseif pad:start() then bt = 12
      end
    oldPad = pad
    end
  end
end


function find_random()
  probtype=math.random(4)
  while prbtype[probtype] == 0 do
     probtype=math.random(4)
  end
  hit=1
  while hit == 1 do
    chosen = math.random(hinum*hinum)
    if probtype == 1 then
      if cards[chosen].mult ~= 1 then
        number1 = cards[chosen].num1
        number2 = cards[chosen].num2
        answer = cards[chosen].ans1
        cards[chosen].mult = 1
        cards[((cards[chosen].num2-1)*hinum)+cards[chosen].num1].mult = 1
        hit = 0
      end
    elseif probtype == 2 then
      if cards[chosen].div ~= 1 then
        number1 = cards[chosen].ans1
        number2 = cards[chosen].num1
        answer = cards[chosen].num2
        cards[chosen].div = 1
        hit = 0
      end
    elseif probtype == 3 then
      if cards[chosen].add ~= 1 then
        number1 = cards[chosen].num1
        number2 = cards[chosen].num2
        answer = cards[chosen].ans2
        cards[chosen].add = 1
        cards[((cards[chosen].num2-1)*hinum)+cards[chosen].num1].add = 1
        hit = 0
      end
    elseif probtype == 4 then
      if cards[chosen].min ~= 1 then
        number1 = cards[chosen].ans2
        number2 = cards[chosen].num1
        answer = cards[chosen].num2
        cards[chosen].min = 1
        hit = 0
      end
    end
  end
last_reply = reply
  while last_reply == reply do
    reply=math.random(num_snd)
  end
  return chosen
end

function reset_guess()
  for a = 1,3 do
    guess[a] = 0
    no_guess[a] = 0
  end
  no_guess[3]=1
  row=3
  timer:reset()
end

function disp()
  screen:clear()
  msg = score .." / " .. count
  cur_ans = number1 .. " " .. oper[probtype] .. " " .. number2 .. " = " .. answer
  msg2 = pre_ans
  player_guess = guess[1]*100 + guess[2]*10 + guess[3]
    spc = 0
    l=string.len(number1)
    for i = 1, l do
      number = string.sub(number1,i,i)
      number = number +1 -1
      screen:blit(prbx+(spc),prby,tiles[tile_type], 50*number, 0, 50, 50)
      spc = spc + width
    end
    screen:blit(prbx+spc,prby, tiles[tile_type], 30*probtype-30, 51, 30,50)
    spc = spc + opr_width
    l=string.len(number2)
    for i = 1, l do
      number = string.sub(number2,i,i)
      number = number +1 -1
      screen:blit(prbx+(spc),prby,tiles[tile_type], 50*number, 0, 50, 50)
      spc = spc + width
    end
    screen:blit(prbx+spc,prby, tiles[tile_type], 30*4, 51, 30,50)
    spc = spc + opr_width
  spc=0
  for a = 1,3 do
     if no_guess[a]~=0 then
        screen:blit(ansx+(spc),ansy,tiles[tile_type], 50*guess[a], 0, 50, 50)
        spc = spc + width
     else
        screen:blit(ansx+spc,ansy,image[3])
        spc = spc + width
     end
  end
  screen:blit(ansx,ansy+50,image[10])
  screen:blit(ansx+width,ansy+50, image[10])
  screen:blit(ansx+width*2,ansy+50, image[10])
  screen:blit(ansx+(width*row)-width,ansy+50,image[4])
  screen:blit(5,235,image[7])
  screen:blit(90,235,image[9])
  screen:blit(160,235,image[8])
  screen:blit(370,5,image[11])
  screen:blit(350,25,image[12])
  screen:blit(350,140, image[12])
  screen:print (400, 40, msg, green)
  screen:print (375, 100, msg2, yellow)
  screen:print (385, 120, last_guess, green)
  screen:print (33, 248,"=Enter", white)
  screen:print (116, 248, "=End", white)
  screen:print (188, 248, "=Music toggle", white)
  screen:print (375, 140, "Last", white)
  screen:print (375, 150, "Time", white)
  tmp2 = string.format ("%i",pass/100)
  screen:print (420, 145, "= " .. tmp2/10, white)
  off = string.len(pointscore) + 1
  screen:print (415-off, 80, pointscore, red)
  screen:print (370, 255, "Hi-Score " .. high[cur], red)
  screen.flip()
  screen.waitVblankStart()
end

function next()
  find_random()
  reset_guess()
  show = disp()
  timer:start()
end

function play_now()
  while count < play_to do
    get_key()
    check_key()
  end
end

function check_key()
   if bt == 1 then guess[row]=guess[row]+1 end
   if bt == 2 then guess[row]=guess[row]-1 end
   if bt == 3 then row=row-1 end
   if bt == 4 then row=row+1 end
   if bt == 5 then
      if Music.playing() then
         Music.stop()
      else
         Music.playFile(song, true)
      end
   end
   if bt == 7 then
     pass = timer:stop()
     tottime=tottime + string.format ("%i",pass/10)
        if player_guess == answer then
           right[reply]:play()
           last_guess = "Correct!!"
           score = score + 1
           seconds = 0 + string.format ("%i",pass/1000)
           if seconds > hitime then seconds = hitime end
           steps = string.format ("%i",seconds/hicount)
           addme = (hicount - steps)*hipts
           pointscore = pointscore + addme
        else
           wrong[reply]:play()
           last_guess = "Wrong!!"
        end
     count = count + 1
     pre_ans=cur_ans
     if count < play_to then
        next()
        screen.flip()
     end
   end
   if bt == 8 then
      count = play_to
   end
   if row >3 then row = 1 end
   if row <1 then row = 3 end
   if guess[row] > 9 then guess[row]=0 end
   if guess[row] < 0 then guess[row]=9 end
   no_guess[row] = 1
   show=disp()
end

function disp_intro()
  screen:clear()
  screen:blit(1,10,image[5])
  screen:blit(130,225,image[7])
  screen:blit(215,225,image[6])
  screen:blit(290,225,image[8])
  screen:blit(380,225,image[14])
  screen:blit(400,145,tiles[tile_type], 50, 0, 50, 50)
  for a = 1,4 do
    if cur == a then q = 15 else q = 16 end
    screen:blit(275,110+(a*20),image[q])
  end
  for a = 1,4 do
    if prbtype[a] == 1 then q = 15 else q = 16 end
    screen:blit(175,110+(a*20),image[q])
  end
  if inrow == 1 then
     xx = 174
  else
     xx=274
  end
  screen:blit(xx,110+(pb*20)-1,image[17])
  screen:print (160, 235, "=Toggle", green)
  screen:print (245, 235, "=Font", green)
  screen:print (320, 235, "=Music", green)
  screen:print (300, 133, "10 Problems", white)
  screen:print (300, 153, "25 Problems", white)
  screen:print (300, 173, "50 Problems", white)
  screen:print (300, 193, "75 Problems", white)
  screen:print (200, 133, "Multiply", white)
  screen:print (200, 153, "Divide", white)
  screen:print (200, 173, "Add", white)
  screen:print (200, 193, "Subtract", white)
  screen:print (410, 133, "Font", white)
  screen:flip()
  screen.waitVblankStart()
end


function intro()
  disp_intro()
  bt = 0
  while bt ~= 12 do
    get_key()
    if bt == 3 then inrow = inrow -1 end
    if bt == 4 then inrow = inrow +1 end
    if bt == 1 then pb = pb -1 end
    if bt == 2 then pb = pb +1 end
    if bt == 5 then
	if Music.playing() then
           Music.stop()
	else
	   Music.playFile(song, true)
	end
    end
    if bt == 6 then
        tile_type = tile_type + 1
        if tile_type > 2 then tile_type = 1 end
    end
    if bt == 7 then
       if inrow == 1 then
          if prbtype[pb] == 1 then
             prbtype[pb] = 0
             else
             prbtype[pb] = 1
          end
       else
          cur = pb
       end
    end
    if pb < 1 then pb = 1 end
    if pb > 4 then pb = 4 end
    if inrow > 2 then inrow = 2 end
    if inrow < 1 then inrow = 1 end
    disp_intro()
    play_to = problems[cur]
  end
  ct = 0 -- set default problem type to multiply if nothing selected
  for a = 1,4 do
    ct = ct + prbtype[a]
  end
  if ct == 0 then prbtype[1]=1 end
end

function disp_grade()
  disp()
  pic=23
  grade = score/play_to
  if grade >= 0.9 then pic = 0
    elseif grade >= 0.8 then pic = 1
    elseif grade >= 0.7 then pic = 2
    elseif grade >= 0.6 then pic = 3
    else pic = 4
  end
  screen:blit(395,170,grades, 60*pic, 0, 60, 60)
  screen:blit(0,35,image[13])
  screen:print(400,240,"GRADE",white)
  screen:print (85, 195, "Average Time To Answer", green)
  screen:print (125, 210, (tottime/play_to)/100 .. " Seconds!"  , yellow)
  if newhi == 1 then
    screen:blit(65,235,image[1])
    spec[1]:play()
    newhi = 0
  end
  if perfect == 1 then
    spec[1]:play()
    perfect = 0
    screen:blit(10,10,image[2])
  end
  screen.flip()
  screen.waitVblankStart()
  bt = 0
  while bt ~= 12 do
    get_key()
  end
end

function savehi()
  high[cur] = pointscore
  file = io.open(hifile, "w")
  if file then
    for a = 1,4 do
      file:write(high[a] .. "\n")
    end
    file:close()
    newhi = 1
  end
end

function loadhi()
  file = io.open(hifile, "r")
  if file then
    for a = 1,4 do
      high[a] = file:read("*n")
    end
  file:close()
  end
end

function wait(sec)
  timer:reset()
  timer:start()
  while timer:time() < sec * 1000 do
  end
  timer:stop()
end

-- Main Program --
while true do
  intro()
  loadhi()
  new_game()
  next()
  play_now()
  if pointscore > high[cur] then
     savehi()
  end
  if pointscore == play_to * hicount * hipts then
     perfect = 1
  end
  disp_grade()
end

